<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_installation_user".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnInstallationUser".
 *
 * Columns in table "cpn_installation_user" available as properties of the model,
 * followed by relations of table "cpn_installation_user" available as properties of the model.
 *
 * @property integer $id
 * @property integer $cpn_installation_id
 * @property string $ehr_user_id
 * @property string $ehr_user_data
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * @property CpnInstallationProvider[] $cpnInstallationProviders
 * @property Account $addedByAccount
 * @property CpnInstallation $cpnInstallation
 */
abstract class BaseCpnInstallationUser extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_installation_user';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnInstallationUser|CpnInstallationUsers', $n);
    }

    public static function representingColumn()
    {
        return 'ehr_user_id';
    }

    public function rules()
    {
        return array(
            array('cpn_installation_id, ehr_user_id, ehr_user_data, added_by_account_id', 'required'),
            array('cpn_installation_id, added_by_account_id, updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('ehr_user_id', 'length', 'max' => 25),
            array('ehr_user_data', 'length', 'max' => 254),
            array('date_added, date_updated', 'safe'),
            array('date_added, date_updated, updated_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, cpn_installation_id, ehr_user_id, ehr_user_data, date_added, added_by_account_id, date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'cpnInstallationProviders' => array(self::HAS_MANY, 'CpnInstallationProvider', 'cpn_installation_user_id'),
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'cpnInstallation' => array(self::BELONGS_TO, 'CpnInstallation', 'cpn_installation_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'cpn_installation_id' => null,
            'ehr_user_id' => Yii::t('app', 'Ehr User'),
            'ehr_user_data' => Yii::t('app', 'Ehr User Data'),
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'cpnInstallationProviders' => null,
            'addedByAccount' => null,
            'cpnInstallation' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('cpn_installation_id', $this->cpn_installation_id);
        $criteria->compare('ehr_user_id', $this->ehr_user_id, true);
        $criteria->compare('ehr_user_data', $this->ehr_user_data, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
